medialibrary/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'medialibrary'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^api/$', views.api_index, name='api_index'),
]

presenterclub/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls.static import static
from django.conf.urls import url, include
from django.conf import settings
from django.contrib import admin

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url('^accounts/', include('django.contrib.auth.urls')),
    url('', include('promo.urls')),
    url(r'^u/(?P<username>.+)/medialibrary/', include('medialibrary.urls')),
    url(r'^u/(?P<username>.+)/styles/', include('styles.urls')),
    url(r'^u/', include('u.urls')),
    url(r'^imagesearch/', include('imagesearch.urls')),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

promo/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url
from django.views.generic import TemplateView

from . import views

app_name = 'promo'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^signup$', views.signup, name='signup'),
    url(r'^signup/choose-plan$', views.choose_plan, name='chooseplan'),
    url(r'^go-pro$', views.go_pro, name='gopro'),
    url(r'^accounts/validateemail?token=(?P<token>.+)$',
        views.validate_email,
        name='validateemail'),
    url(r'^accounts/profile/$', views.accounts_profile),

    url(r'^terms$', TemplateView.as_view(template_name='promo/terms.html')),
    url(r'^plans$', TemplateView.as_view(template_name='promo/plans.html'),
        name='plans'),
]

styles/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'styles'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    url(r'^api$', views.api, name='api'),
    url(r'^create$', views.create, name='create'),
    url(r'^(?P<styleid>\d+)$', views.get, name='get'),
    url(r'^(?P<styleid>\d+)/edit$', views.edit, name='edit'),
    url(r'^(?P<styleid>\d+)/thumb.png$', views.thumb, name='thumb'),
    url(r'^(?P<styleid>\d+)/genthumb/(?P<key>.+)$',
        views.genthumb, name='genthumb'),
]

u/urls.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

from django.conf.urls import url

from . import views

app_name = 'u'
urlpatterns = [
    url(r'^$', views.index, name='index'),
    # Ex. /u/sam/
    url(r'^(?P<username>.+)/$', views.userpage, name='userpage'),
    url(r'^(?P<username>.+)/onboarding-status$', views.onboarding_status,
        name='onboardingstatus'),
    url(r'^(?P<username>.+)/create$', views.create, name='create'),
    url(r'^(?P<username>.+)/create.json$',
        views.create_json, name='createjson'),
    url(r'^(?P<username>.+)/settings/profile$',
        views.user_settings, name='usersettings'),
    url(r'^(?P<username>.+)/settings/plan$',
        views.user_plan, name='userplan'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/view$',
        views.view, name='view'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/view.json$',
        views.view_json, name='viewjson'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/edit$',
        views.edit, name='edit'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/delete$',
        views.delete_presentation, name='deletepresentation'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/thumb.png$',
        views.thumb, name='thumb'),
    url(r'^(?P<username>.+)/(?P<presentationid>.+)/genthumb/(?P<key>.+)$',
        views.genthumb, name='genthumb'),
]

u/models.py
# Presenter Club - Make Great Presentations, Faster
# Copyright (C) 2016 Sam Parkinson <sam@sam.today>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import json
import bleach
from django.db import models

from django.contrib.auth.models import User

from styles.models import DEFAULT_STYLE


ALLOWED_TAGS = bleach.ALLOWED_TAGS + ['u', 'p']


def is_pro_user(user):
    profile = UserProfile.objects.get(user=user)
    return profile.has_pro or profile.has_pro_for_free


class UserProfile(models.Model):
    user = models.OneToOneField(User)

    has_validated_email = models.BooleanField(default=False)

    stripe_customer = models.TextField(null=True)
    has_pro = models.BooleanField(default=False)
    has_pro_for_free = models.BooleanField(default=False)

    name = models.TextField('Name (publicly displayed)')
    bio = models.TextField('Bio Text (publicly displayed)', blank=True)

    onboarding_status = models.IntegerField('Onboarding status', default=0)


_DEFAULT_JSON = json.dumps({
    'speech': [{
        'indent': 0,
        'uuid': '00000000-0000-0000-0000000000000000',
        'slideType': None,
    }]
})


def thumb_directory_path(instance, filename):
    return 'presentation_thumbs/{0}/{1}.png'.format(
        instance.user.id, instance.id)


class Presentation(models.Model):
    user = models.ForeignKey(User, on_delete=models.DO_NOTHING)

    created_time = models.DateTimeField('Created', auto_now_add=True)
    edited_time = models.DateTimeField('Edited', auto_now=True)

    title = models.TextField('Title (publicly displayed)')
    data = models.TextField('Data with speech, internal JSON format',
                            default=_DEFAULT_JSON)

    number_rows_slide = models.IntegerField('Number of rows with a slide',
                                            default=0)
    number_rows = models.IntegerField('Number of rows (w or wo slides)',
                                      default=1)

    PRIVATE = 'l'
    NOTES_HIDDEN = 'h'
    PUBLIC = 'o'
    PRIVACY_CHOICES = (
        (PRIVATE, 'Private'),
        (NOTES_HIDDEN, 'Public Slides, Private Notes'),
        (PUBLIC, 'Public')
    )
    privacy = models.CharField(
        'Privacy Mode',
        max_length=1,
        choices=PRIVACY_CHOICES,
        default=NOTES_HIDDEN
    )

    thumb = models.FileField(upload_to=thumb_directory_path, null=True)
    thumb_edited_time = models.DateTimeField(
        'When the thumbnail was last updated',
        null=True)

    def get_style_id(self) -> int:
        d = json.loads(self.data)
        if d.get('style') is None:
            return DEFAULT_STYLE
        return d['style'].get('id')

    @staticmethod
    def bleach_data(data: dict):
        def _fix(html):
            after = bleach.clean(html, strip=True, tags=ALLOWED_TAGS)
            return bleach.clean(html, strip=True, tags=ALLOWED_TAGS)

        def _fix_block(block):
            if 'html' in block:
                block['html'] = _fix(block['html'])
            return block

        def _fix_speech_row(row):
            if 'idea' in row:
                row['idea'] = _fix(row['idea'])
            if 'execution' in row:
                row['execution'] = _fix(row['execution'])
            if 'blocks' in row:
                row['blocks'] = list(map(_fix_block, row['blocks']))
            return row

        if 'speech' in data:
            data['speech'] = list(map(_fix_speech_row, data['speech']))
        return data

u/templates/u/ERRneedvalidemail.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}Presenter Club{% endblock title %}

{% block content %}
<p>You need to validate your email before you can start using Presenter Club</p>

<p>Please check the email that we have sent to {{ user.email }}, and see the
   link in the email.</p>

<p>If you are having any problems, don't hesitate to contact us at
   <a href="mailto:hi@presenter.club">hi@presenter.club</a> and we will fix
   the issue.</p>
{% endblock content %}

u/templates/u/app.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}
{% load render_bundle from webpack_loader %}

{% block title %}Edit {{ presentation.title }} on Presenter Club{% endblock title %}

{% block header %}
{% endblock header %}

{% block main %}
<div id="react-container">
    <div class="Loader"></div>
</div>
{% endblock main %}

{% block end %}
    <script>
        {% include 'base/djangosUser.js' %}
        window.djangosGift = {{ json_string | safe }};

        {% load u %}
        window.djangoOnboardStatus = {{ profile.onboarding_status | jsonify }};
        window.enableHeavyBranding = !{{ viewing | isprouser | jsonify }};
    </script>

    {% render_bundle 'u_edit' 'js' %}
{% endblock end %}

u/templates/u/createjson.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}Settings on Presenter Club{% endblock title %}

{% block content %}
<h1>Import Presentation JSON</h1>
<form method="post" action="{% url 'u:createjson' user.username %}">
    {% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Create" />
</form>
{% endblock content %}

u/templates/u/deletepresentation.html
{% extends "base/normal.html" %}

{% block title %}Delete {{ p.title }} from Presenter Club{% endblock title %}

{% block content %}
<h2>Delete {{ p.title }}</h2>
<p>Are you 100% sure that you want to delete <i>{{ p.title }}</i>?  There is no
   way to recover it later.</p>
{% if is_pro %}
    <p>Alternatively, you can <b>make your presentation private</b> in the editor.
       Just <a href="{% url 'u:edit' user.username p.id %}">open the editor</a>,
       click the title at the top then select private from the "privacy" dropdown.</p>
{% else %}
    <p>Alternatively, you can <b>make your presentation private</b> with
       Presenter Club Pro.  Only you will be able to see it once it is private.
       <a href='{% url 'promo:plans' %}'>Learn more about Pro on the
       plans page</a>.</p>
{% endif %}
<form method="post">
    {% csrf_token %}
    <input type="submit" value="Delete it forever" />
</form>
{% endblock content %}

u/templates/u/index.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block main %}
<div class='LoaderProgress LoaderProgress--1digit'>
    <div class='LoaderProgress__normal'>9%</div>
    <div class='LoaderProgress__insert' style='width: 8;'>9%</div>
</div>
{% endblock main %}

u/templates/u/thumbs.html
{% load staticfiles %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% load render_bundle from webpack_loader %}

<html>
    <head>
        <link rel="stylesheet" href="{% static 'css/main.css' %}" />
    </head>

    <body>
        <div id="react-container"></div>
        <script>
            window.djangosGift = {{ json_string | safe }};
            {% load styles %}
            {{ presentation | djangosStyle | safe }}
        </script>
        {% render_bundle 'u_genthumb' 'js' %}
    </body>
</html>

u/templates/u/userpage-presentations.html
{% extends "u/userpage.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block userpagemain %}
{% if not presentations and viewing != user %}
    <p>Right now, {{ profile.name }} doesn't have any presentations.</p>
{% else %}
    <ul class='PresentationList__ul'>
    {% for p in presentations %}
        <li class='emphasisbox__parent'>
            <a href="{% url 'u:view' viewing.username p.id %}"
               title='View Presentation'
               class='PresentationList__item emphasisbox__left'>
                <img src="{% url 'u:thumb' viewing.username p.id %}" 
                     alt="Thumbnail"
                     width="320px" height="180px"
                     class='PresentationList__thumb'>
                <div class='PresentationList__title'>
                    <h2>{{ p.title }}</h2>
                    {% if viewing == user %}
                        <div class='PresentationList__title__byline'>
                            {{ p.get_privacy_display }}
                        </div>
                    {% endif %}
                </div>
            </a>
            {% if user == viewing %}
                <div class='PresentationList__actions emphasisbox__actions'>
                    <a class="button small"
                       href="{% url 'u:edit' viewing.username p.id %}">Edit</a>
                    <a class="button small"
                       href="{% url 'u:deletepresentation' viewing.username p.id %}">Delete</a>
                </div>
            {% else %}
                <div class='PresentationList__actions emphasisbox__actions'>
                    <a class="button small"
                       href="{% url 'u:view' viewing.username p.id %}">View</a>
                </div>
            {% endif %}
        </a></li>
    {% endfor %}

    {% if user == viewing %}
        <a href='{% url 'u:create' viewing.username %}'
           class='PresentationList__create_new button special'
           title='New Presentation'>
            New Presentation
        </a>
    {% endif %}
    </ul>
{% endif %}
{% endblock userpagemain %}

u/templates/u/userpage.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}{{ viewing.username }} on Presenter Club{% endblock title %}

{% block content %}
{% if user == viewing %}
    <div class="title-n-button">
        <h1>Your Presentations
            {% if is_pro %}<span class='ProBadge'>Pro</span>{% endif %}
        </h1>
        <a href="{% url 'u:create' username=user.username %}"
           class="button special small">
            New Presentation
        </a>
        <a href="{% url 'u:usersettings' username=user.username %}"
           class="button small">
            Settings
        </a>
        <a href="/accounts/logout/"
           class="button small">
            Logout
        </a>
    </div>
{% else %}
    <h1>
        {{ profile.name }}'s Presentations
        {% if is_pro %}<span class='ProBadge'>Pro</span>{% endif %}
    </h1>
{% endif %}
{% if not is_pro and viewing == user and presentations %}
    <p><a href='{% url 'promo:gopro' %}'>Upgrade to Pro</a> to unlock private
       presentations, custom styles, the concierge style service and
       remove the "Made with Presenter Club" logo.</p>
{% endif %}
<p>{{ profile.bio }}</p>

{% comment %}
{% if user == viewing and not profile.has_validated_email and presentations %}
    <p><b>You need to validate your email before you can start using Presenter
       Club.</b>  Please see the link that we sent to your email,
       <i>{{ viewing.email }}</i>.  If there is an issue, please do not
       hesitate to email us via <a href="mailto:hi@presenter.club">
       hi@presenter.club</a> and we will fix the issue</p>
{% endif %}
{% endcomment %}

{% if user == viewing %}
    <div class="Tabs">
        <div class="Tabs__head">
            <a class="Tabs__head__label"
               href="{% url 'medialibrary:index' username=user.username %}">
                Media Library
            </a>
            <a class="Tabs__head__label Tabs__head__label--selected"
               href="{% url 'u:userpage' username=user.username %}">
                Presentations
            </a>
            <a class="Tabs__head__label"
               href="{% url 'styles:index' username=user.username %}">
                Styles
            </a>
        </div>
        <div class="Tabs__content">
{% endif %}
    {% block userpagemain %}{% endblock userpagemain %}
{% if user == viewing %}
        </div>
    </div>
{% endif %}


{% endblock content %}

u/templates/u/userplan.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}Settings on Presenter Club{% endblock title %}

{% block content %}
<div class="Tabs">
    <div class="Tabs__head">
        <a class="Tabs__head__label Tabs__head__label--selected"
           href="{% url 'u:userplan' username=user.username %}">
            Plan & Payment
        </a>
        <a class="Tabs__head__label"
           href="{% url 'u:usersettings' username=user.username %}">
            Profile
        </a>
    </div>
    <div class="Tabs__content">
        <p>You are currently subscribed to Presenter Club Pro.  For more
           information, contact us via
           <a href='mailto:hi@presenter.club'>hi@presenter.club</a>.
        </p>
    </div>
</div>
{% endblock content %}

u/templates/u/usersettings.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% block title %}Settings on Presenter Club{% endblock title %}

{% block content %}
<div class="Tabs">
    <div class="Tabs__head">
        <a class="Tabs__head__label"
           href="{% url 'u:userplan' username=user.username %}">
            Plan & Payment
        </a>
        <a class="Tabs__head__label Tabs__head__label--selected"
           href="{% url 'u:usersettings' username=user.username %}">
            Profile
        </a>
    </div>
    <div class="Tabs__content">
        <form method="post" action="{% url 'u:usersettings' user.username %}">
            {% csrf_token %}
            {{ profile_form.as_p }}
            <input type="submit" value="Save" />
        </form>
    </div>
</div>
{% endblock content %}

u/templates/u/view.html
{% extends "base/normal.html" %}

{% comment %}
Presenter Club - Make Great Presentations, Faster
Copyright (C) 2016 Sam Parkinson <sam@sam.today>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
{% endcomment %}

{% load render_bundle from webpack_loader %}

{% block title %}{{ presentation.title }} on Presenter Club{% endblock title %}

{% block endhead %}
<meta name="twitter:card" content="summary_large_image" />
<meta name="twitter:site" content="@PresenterClub" />
<meta property="og:url" content="{{ request.build_absolute_uri }}" />
<meta property="og:title" content="{{ presentation.title }}" />
<meta property="og:description" content="Presentation by {{ viewing_profile.name }} on Presenter Club" />
<meta property="og:image" content="{{ thumb_url }}" />
<meta property="og:image:width" content="320" />
<meta property="og:image:height" content="180" />

{% endblock endhead %}

{% block main %}
<div id="react-container">
    <div class="Loader"></div>
</div>
{% endblock main %}

{% block end %}
    <script>
        window.djangosGift = {{ json_string | safe }};
        window.djangosViewingMyself =
            {% if user == viewing_user %}true{% else %}false{% endif %};
        window.djangosViewingProfile = {
            name: '{{ viewing_profile.name }}'
        };

        {% load u %}
        window.enableHeavyBranding = !{{ viewing_user | isprouser | jsonify }};

        {% load styles %}
        {{ presentation | djangosStyle | safe }}
    </script>
    {% render_bundle 'u_view' 'js' %}
{% endblock end %}